var createError = require('http-errors');
var express = require('express');
var path = require('path');
var cookieParser = require('cookie-parser');
var logger = require('morgan');
var bodyParser = require('body-parser');
var middleware = require('./middleware');
var app = express();


const login = require('./routes/login');
const init = require('./routes/init');

// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'jade');

app.use(logger('dev'));

app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));
app.use(bodyParser.json({ limit: '50mb' }));
app.use(bodyParser.urlencoded({ limit: '50mb', extended: true, parameterLimit: 50000 }));

app.use(function(req, res, next) {
  res.header("Access-Control-Allow-Origin", "*");
  res.header("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept");
  next();
});

const data = [
  {
    "text": "workout",
    "isChecked": false,
    "isDeleted": false,
  },
  {
    "text": "go to college",
    "isChecked": false,
    "isDeleted": false,
  },
  {
    "text": "submit exam form",
    "isChecked": false,
    "isDeleted": false,
  },
  {
    "text": "call xyz",
    "isChecked": false,
    "isDeleted": false,
  },
  {
    "text": "plan for 31st dec",
    "isChecked": false,
    "isDeleted": false,
  }
]

app.use('/getData', (req, res, next) => {
  res.send(data);
})

app.use(middleware);

app.use('/login', login);
app.use('/init', init)


// catch 404 and forward to error handler
app.use(function (req, res, next) {
  next(createError(404));
});

// error handler
app.use(function (err, req, res, next) {
  // set locals, only providing error in development
  res.locals.message = err.message;
  res.locals.error = req.app.get('env') === 'development' ? err : {};

  // render the error page
  res.status(err.status || 500);
  res.render('error');
});

module.exports = app;
